﻿using UnityEngine;
using System.Collections;

public class LineRendererColorFader : MonoBehaviour {

    public WorldController controller;
    public Color targetStartColor;
    public Color targetEndColor;
    private LineRenderer lineRenderer;

    void Start() {
        lineRenderer = GetComponent<LineRenderer>();
    }

    void Update() {
        lineRenderer.SetColors( controller.getFadedColor( controller.foregroundStartingColor, getTargetStartColor() ),
                                controller.getFadedColor( controller.foregroundStartingColor, getTargetEndColor() ) );
    }

    Color getTargetStartColor() {
        if ( controller.isWinning() ) {
            return targetStartColor;
        }
        return controller.foregroundLosingColor;
    }

    Color getTargetEndColor() {
        if ( controller.isWinning() ) {
            return targetEndColor;
        }
        return controller.foregroundLosingColor;
    }
}
