﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class GlobalController : MonoBehaviour {
    public int currentStep;
    public int winningStep;
    public int losingStep;
    private int score = 0;
    public GameObject originalColorball;
    public int colorballSpawnTime = 1200;
    public int nextColorballCountdown = 0;
    public bool gameIsOn = true;

    public int bombSpawnTime = 350;
    public int nextBombCountdown = 0;
    public GameObject originalBomb;

    public Player whitePlayer;
    public Player blackPlayer;

    public GameObject gamePlayUI;
    public GameObject endGameUI;
    public Text scoreText;
    public Text FinalScoreText;

    public WorldController whiteWorldController;
    public WorldController blackWorldController;

    void Start() {
        updateUI();
    }

    void Update() {
        /*currentStep += ( int )( Input.GetAxis( "Mouse ScrollWheel" ) * 10.0f );*/
        if ( gameIsOn ) {
            nextColorballCountdown--;
            nextBombCountdown--;
            if ( nextColorballCountdown <= 0 ) {
                GameObject colorball = Instantiate( originalColorball );
                nextColorballCountdown = colorballSpawnTime;
            }
            if ( nextBombCountdown <= 0 ) {
                GameObject bomb = Instantiate( originalBomb );
                nextBombCountdown = bombSpawnTime;
            }
            if ( currentStep <= losingStep ) {
                gameIsOn = false;
            }
        }

        if ( !gameIsOn ) {
            gamePlayUI.SetActive( false );
            endGameUI.SetActive( true );
        }
    }

    public float getProgress() {
        float step = ( float )( Mathf.Abs( currentStep ) );
        float targetStep;
        if ( isWinning() ) {
            targetStep = Mathf.Abs( ( float )winningStep );
        } else {
            targetStep = Mathf.Abs( ( float )losingStep );
        }
        return Mathf.Max( 0.0f, Mathf.Min( 1.0f, step / targetStep ) );
    }

    public bool isWinning() {
        if ( currentStep >= 0 ) {
            return true;
        }
        return false;
    }

    public void incrementScore() {
        currentStep = ( int )Mathf.Min( winningStep, ++currentStep );
        score++;
        updateUI();
    }

    public void loseStep() {
        currentStep = ( int )Mathf.Max( losingStep, --currentStep );
        updateUI();
    }

    void updateUI() {
        scoreText.text = "Score: " + score;
        FinalScoreText.text = "FINAL SCORE\n" + score;
    }

    public void resetGame() {
        Application.LoadLevel( Application.loadedLevel );
    }
}
