﻿using UnityEngine;
using System.Collections;

public class Missile : MonoBehaviour {

    private GlobalController globalController;
    public MissileParent parent;
    private bool white;

    void Start() {
        globalController = GameObject.FindObjectOfType<GlobalController>();
        // Spawn randomly
        white = Random.Range( 0.0f, 1.0f ) >= 0.5f;
        if ( white ) {
            parent.transform.position = globalController.whiteWorldController.transform.position + new Vector3( Random.RandomRange( -15.0f, 15.0f ), Random.Range( -5.0f, 5.0f ), 10.0f );
        } else {
            parent.transform.position = globalController.blackWorldController.transform.position + new Vector3( Random.RandomRange( -15.0f, 15.0f ), Random.Range( -5.0f, 5.0f ), 10.0f );
        }
        Player[] players = GameObject.FindObjectsOfType<Player>();
        foreach ( Player player in players ) {
            if ( ( parent.transform.position - player.transform.position ).magnitude < 4.0f ) {
                Debug.Log( "Spawned too close " );
                if ( parent.transform.position.x < player.transform.position.x ) {
                    parent.transform.position = new Vector3( parent.transform.position.x - 4.0f, parent.transform.position.y, parent.transform.position.z );
                } else {
                    parent.transform.position = new Vector3( parent.transform.position.x + 4.0f, parent.transform.position.y, parent.transform.position.z );
                }
            }
        }
    }

    void Update() {
        if ( white ) {
            if ( transform.position.x < globalController.whiteWorldController.transform.position.x - 15.0f ||
                 transform.position.x > globalController.whiteWorldController.transform.position.x + 15.0f ||
                 transform.position.y < globalController.whiteWorldController.transform.position.y - 5.0f ||
                 transform.position.y > globalController.whiteWorldController.transform.position.y + 5.0f ) {
                Destroy( this.GetComponentInParent<Transform>().gameObject );
            }
        } else {
            if ( transform.position.x < globalController.blackWorldController.transform.position.x - 15.0f ||
                 transform.position.x > globalController.blackWorldController.transform.position.x + 15.0f ||
                 transform.position.y < globalController.blackWorldController.transform.position.y - 5.0f ||
                 transform.position.y > globalController.blackWorldController.transform.position.y + 5.0f ) {
                Destroy( this.GetComponentInParent<Transform>().gameObject );
            }
        }
    }

    void OnCollisionEnter2D( Collision2D other ) {
        PlayerBlackWorld player = other.gameObject.GetComponent<PlayerBlackWorld>();
        if ( player ) {
            if ( player.getTongueIsReaching() ) {
                Destroy( this.GetComponentInParent<Transform>().gameObject );
                return;
            }
        }
        globalController.loseStep();
        Destroy( this.GetComponentInParent<Transform>().gameObject );
    }
}